# Bienvenidos a `rust!ang-es` 🦀!

Hola! Y bienvenidos a `rust!ang-es`. 

Este proyecto ha sido creado POR y PARA la difusión del lenguaje de programación conocido cómo `Rust` y del eco-sistema de [`rust-lang`](https://www.rust-lang.org/es/). Aquí encontrarás una serie de documentos, ejemplos y ejercicios en Castellano que te ayudarán a iniciarte en el maravilloso mundo de Rust!

## Pero... y que es RUST?

Rust es un lenguaje multiparadigma y multipropósito que inicialmente fue orientado a la programación de sistemas. 
Gracias a su construcción, es un lenguaje extremademente rápido y además tremendamente seguro, con una capacidad de manejo de la memoria completo y fuera de peligro, siendo esta la cualidad más novedosa del mismo gracias a un concepto novedoso conocido como `ownership (propiedad)`.
Esto todo es lo que hace que su poder de desarrollo se extienda a más áreas de las intencionadas inicialmente, en parte debido a que Mozilla fué uno de sus grandes impulsores y en parte al impulso de la comunidad open-source y el maravilloso ecosistema que hay alrededor de Rust, y que ha hecho crecer este lenguaje hasta lo que conocemos hoy en día, siendo utilizado tanto en back-end y servidores, como embebiendo JavaScript y empoderando el front-end a través de WebAssembly entre otros. 

### Código de conducta
Como curiosidad, te dejo en enlace al [código de conducta de Rust](https://www.rust-lang.org/es/policies/code-of-conduct) para que le eches una ojeada y entiendas el por qué su comunidad es como es! :)

Dicho esto hay que recordar que Rust todavía sigue siendo un bebé, ya que su primera versión oficial fué lanzada al público en 2015, pero contando que su primer diseño fue en 2006, y el apoyo de Mozilla se formalizó en 2009, tenemos ante nosotros a un lenguaje realmente bien diseñado, adelantado a su tiempo y pionero de la revolución en las nuevas tecnologías del software.

Su historia comenzó gracias a un ingeniero de Mozilla que en busca de un lenguaje que permitiera escribir un código verdaderamente rápido (al mismo nivel que C o C++) pero sin los problemas de gestión de memoria que habían llevado históricamente a estos lenguajes a ser extremadamente deficientes en la gestión de graves bugs en el acceso de memoria y en tiempo de ejecución, acabó por toparse con la idea que lo llevaría a él y a sus colegas a esto que hoy día nos traemos entre manos.

Rust, por otra parte, es ideal para mejorar los tiempos de desarrollo debiado a gran capacidad de abstración (esto es, que permite escribir código más lejos del lenguaje de las máquinas y más cerca de algo parecido a lenguaje de humanos) y además, cuenta con un período de desarrollo de 6 semanas, con lo que que pasado ese tiempo, una nueva versión de Rust es publicada en aras de mejorar el lenguaje o de corregir defectos del mismo.

## Es este un canal oficial?

Ni mucho menos. Aquí encontráreis un curso completamente gratuíto y con ejemplos sobre Rust, y ante todo, apoyado en la estructura del método provisto por los creadores, que es conocido como **EL LIBRO**. Seguiremos en parte su estructura y en otros puntos reorganizaremos los conceptos a la vez que los ampliamos e incluímos más ejemplos prácticos, ya que **EL LIBRO** asume [(aquí)](https://doc.rust-lang.org/book/ch00-00-introduction.html) que todo el mundo ya DOMINA un lenguaje de programación al menos y que se desenvuelve con soltura en los fundamentos de la programación informática.

De cualquier manera, quiero recalcar que esta solo es una contribución altruísta al mundo Rust, y que se apoya en la documentación oficial para disponer de un buen patrón sobre el que sentar las bases a los lectores, pero que ni mucho menos representa en su estadío final ninguna voz autorizada de Rust.


## Es cierto que RUST es un lenguaje difícil?

Cierto!... y a la vez no! Y cierto que si deseas iniciarte en el mundo de la programacíon con `Rust` como primer caballo de batalla será un camino un poco más difícil que con lenguajes más óptimos para dicho propósito. Eso si, si eres capaz de engancharte a él, o estás decidido a aprenderlo sea como primer lenguaje o no y continuar hasta el final, habrás superado un camino que te forjará como un habilidoso y fuerte programador multipropósito, capaz de realizar desde programación de sistemas y/o en sistemas embebidos, pasando por el desarrollo web (ha demostrado ser el lenguaje más avanzando en el entorno WebAssembly) e incluso llegar (por supuesto y si así lo deseas) a la programación de videojuegos con motores gráficos completamente escritos en Rust [(aquí)](https://arewegameyet.rs/), siendo capaz de desarrollarte profesionalmente en un lenguaje completamente al alza, en permantente desarrollo, con muchísimos puntos fuertes y con los débiles que dependen solamente de tu habilidad para lidiar con los retos.

Si vienes de algún lenguaje de alto nivel, como `Python`, `Javascript` o `Ruby`, por ejemplo, notarás que Rust al principio posee una curva de aprendizaje un tanto difícil, ya que introduce nuevos conceptos a la par que renueva unos cuantos que creías conocer tanto a nivel de sintáxis cómo de desarrollo, y puede ser un tanto chocante.
Como siempre, una vez superado ese nivel, Rust será un gran compañero de camino, ya que llegarás más rápido y en mejores condiciones a los mismos sitios que antes.

Si por contra, vienes de algún lenguaje más íntimamente relacionado con la escritura de código a bajo nivel, preferentemente procedural, estáticamente tipado y probablemente débilmente tipado (esto último daría para mucho debate) como pueden ser los monstruos de `C y C++`, te sorprenderás lo fácil que resulta aprender Rust, a la vez que solucionas los legendarios problemas de este tipo de lenguajes de bugs relativos al acceso y manejo de memoria. 

## Recursos oficiales:

- [El libro](https://doc.rust-lang.org/book/index.html) - Es el recurso más exhaustivo (y oficial) para aprender Rust, pero es un poco difícil de seguir a veces debido a su alta carga teórica y al nivel de detalle que ofrece. De cualquier manera, no hay mejor recurso complementario que la documentación hecha por sus creadores!

- [Rust en ejemplo](https://doc.rust-lang.org/rust-by-example/index.html) - Diseñado para aprender Rust con ejemplos, es una perfecta herramienta para desarrollarte a través de la práctica!

## Descarga Rust

[Descarga](https://www.rust-lang.org/es/tools/install) Rust desde este enlace. Automáticamente, detectará tu OS y te ofrecerá la mejor alternativa para descargar.

El proceso es rápido y guiado, con lo que al terminar habrás instalado Rust en tu ordenador con éxito y estarás listo para unirte al mejor entorno de desarrollo a día de hoy en cuando a desarrollo de software, tanto por características cómo por potencial!

